<?php
include "eh_global.ips.php";
$ds->setname("heizung_wp");
$ds->Log("?  ".str_pad(IPS_GetName($_IPS['SELF']), 80, "=", STR_PAD_RIGHT));

// Automatik Script fr Soll-TEmperturen

// Tageszeiten und werte prfen.
$H  = date("G");
$M  = date("i");
$month = ("n");
$HM = intval($H.$M);
$D  = date("N"); // MOntag = 1

// Basis-Temperturen
$TSollWohnzimmer_Basis = 23;
$TSollBad_Basis        = 22.0;

// Basis-Normal-Temperaturen
$SollWohnzimmer = $TSollWohnzimmer_Basis;
$TSollBad       = $TSollBad_Basis;

# Wochenplan $D: 1 = Montag , 7 = Sonntag
# Stundenformat {Stunde}{Minute}, bsp. 920 = 9:20 Uhr, 1435 = 14:35 Uhr

# Mo - Fr. -----------------------------------------------------
if($D >= 1 && $D <= 5){
    // Morgens 
    if($HM >= 405){         
        $TSollWohnzimmer = $TSollWohnzimmer_Basis;
        $TSollBad        = $TSollBad_Basis + 0.75;
    }

    if($HM >= 700){         
        $TSollWohnzimmer = $TSollWohnzimmer_Basis - 0.25;
        $TSollBad        = $TSollBad_Basis;
    }

    // Ab Mittag Vorheizen
    if($HM >= 1000  && ($month < 5 || $month > 9 ) ){
        $TSollWohnzimmer = $TSollWohnzimmer_Basis + 0.5;
        $TSollBad        = $TSollBad_Basis;
    }

    //Ab Dunkelheit    
    if($HM >= 1600){
        $TSollWohnzimmer = $TSollWohnzimmer_Basis + 0.5;
        $TSollBad        = $TSollBad_Basis + 0.5;
    }

    // Nachtabsenkung Mo-Fr
    if($HM >= 2100 || $HM >= 0 && $HM < 405){  
        $TSollBad        = $TSollBad_Basis;        
    }
    if($HM >= 2200 || $HM >= 0 && $HM < 405){        
        $TSollWohnzimmer = $TSollWohnzimmer_Basis - 0.5;
    }
}

# Sa - So. -----------------------------------------------------
if($D >= 6){
    
    // Morgens 
    if($HM >= 600){ 
        $TSollWohnzimmer = $TSollWohnzimmer_Basis;
        $TSollBad        = $TSollBad_Basis + 0.5;
    }

    // Ab Mittag Vorheizen nur von Okt - April
    if($HM >= 1000 && ($month < 5 || $month > 9 ) ){
        $TSollWohnzimmer = $TSollWohnzimmer_Basis + 1.0;
        $TSollBad        = $TSollBad_Basis;
    }

    //Ab Dunkelheit    
    if($HM >= 1600){
        $TSollWohnzimmer = $TSollWohnzimmer_Basis + 0.5;
        $TSollBad        = $TSollBad_Basis + 0.5;
    }

    // Nachtabsenkung sa-so
    if($HM >= 2100 || $HM >= 0 && $HM < 405){  
        $TSollBad        = $TSollBad_Basis;        
    }    
    if($HM >= 2300 || $HM >= 0 && $HM < 600){        
        $TSollWohnzimmer = $TSollWohnzimmer_Basis - 0.5;
    }
}


// Wenn Urlaubsmodus, dann 21 Grad 
if ( GetValue(11547) == 1){
    $TSollWohnzimmer = 21;
    $TSollBad = 21;
};

// Wenn OverHeat dann wird 1 Grad mehr geheizt
if(getValue(15133)){
    $TSollWohnzimmer = $TSollWohnzimmer +1;
    $TSollBad        = $TSollBad + 1;
    $TSollWohnzimmer = ($TSollWohnzimmer > 24.8 )? 24.8 : $TSollWohnzimmer;
}

// Werte nur setzen, wenn manuell lter als 4h ist.
if(time() - $ds->GetValue("USER_". 49334) > 3600 * 4 ){
    SetValue(49334,$TSollWohnzimmer);
}else{
    $ds->log("Wohnzimmer wird nicht gesetzt. Manuelle nderung wurde gesetzt.");
}
if(time() - $ds->GetValue("USER_". 37728) > 3600 * 4 ){
   SetValue(37728,$TSollBad);
}else{
    $ds->log("Bad wird nicht gesetzt. Manuelle nderung wurde gesetzt.");
}



$ds->log("TMP: Soll-Wohnzimmer: $TSollWohnzimmer");
$ds->log("TMP: Soll-Bad:        $TSollBad");
$ds->save();