<?php

include "eh_global.ips.php";
$ds->setname("heizung_wp");
$ds->Log("?  ".str_pad(IPS_GetName($_IPS['SELF']), 80, "=", STR_PAD_RIGHT));

### EINSTELLUNGEN ####################################################################
$WAITTIME    = 30 * 60; // Maximale 1x pro halbe Stunde einen Befehlt absetzen.
$WAITTIME_ON = 3600; // Maximale 1x  einen Befehlt EIN/AUSSCHALTEN.

$idVLSoll = 10517;
$idVLIst  = 46699;

$wp_state = getValue(19422);

$mode_current  = getValue(34876);
$heat_current  = ( getValue( /* Variable von Heishamon HEAT_ENERGY_PRODUCTION*/ ) + getValue(/* Variable Heishamon DHW_ENERGY_PRODUCTION*/);

### Werte lesen #################################################
$VLSoll = round(getValue($idVLSoll));
$VLIst  = round(getValue($idVLIst));


if( ($ds->VL_lastchange + $WAITTIME < time() )  &&
    ($VLSoll != $VLIst ) && $ds->heat
  ){
    $ds->log("CMD: VL auf WP $VLIst -> $VLSoll");
      RequestAction(20121,$VLSoll);
      $ds->VL_lastchange = time();
}
$txt_heat = ($ds->heat)? "AN" : "AUS";
$txt_dhw  = ($ds->dhw)?  "AN" : "AUS";
$ds->log("CMD: HEAT: $txt_heat");
$ds->log("CMD: DHW:  $txt_dhw");

// Modus setzen
if($ds->heat && !$ds->dhw){
  // Heat Only
  $mode_target = 0;
}

if(!$ds->heat && $ds->dhw){
  // DHW Only
  $mode_target = 3;
}

if($ds->heat && $ds->dhw){
  // Heat and DHW
  $mode_target = 4;
}
$ds->log("CMD: -> Mode ".@$mode_target);

if(!isset($mode_target)){
   
   // WP Ausschalten
   if($wp_state && (time() - $ds->lastONOFF > $WAITTIME_ON ) && !($mode_target == 3 && ( $heat_current >1000 ) ) ){
      $ds->log("CMD: WP wird AUSgeschaltet.");
      RequestAction(18646,0); 
      $ds->lastONOFF = time();
   }
    
}else{

    if($mode_current != $mode_target){
        $ds->log("CMD: Operation Mode wird gesetzt auf $mode_target");
        RequestAction(26469, $mode_target);       
    }

   if(!$wp_state && (time() - $ds->lastONOFF > $WAITTIME_ON ) ){
      $ds->log("CMD: WP wird ANgeschaltet.");
      RequestAction(18646,1); 
      $ds->lastONOFF = time();
   }
}

$ds->save();